% FlexRay Analysis Software, Markus I Huse, NTNU.
function message = FlexRay_Analysis_Software(BP,BM)

[FileName,PathName] = uigetfile('*.txt',...
    'Select the analogue FlexRay sample file');
disp(sprintf( 'Filename: %s', FileName ) )
filename = strcat(PathName,FileName);

% Process the Analogue Samples
Horizon = 11;
Bit_String = FlexRay_A2D_Filter(filename,BP,BM,Horizon); 

% Identify FlexRay Frame from Bit Stream
message = FlexRay_MessageParser(Bit_String);

% Compare Valid frames with total frames
Valid_Messages = 0;
for i = 1:size(message,2)
   
   % Checks of one of the 24-Trailer CRC AND the Header CRC is correct 
   Valid_Messages = ((message(i).Trailer_CRC_A || ...
       message(i).Trailer_CRC_B ) &&...
        message(i).Trailer_CRC_A) + Valid_Messages;
    
end
fprintf( 'Frames that Passed Both CRCs: %d of %d\n',...
    Valid_Messages,size(message,2) ) 
end