% 11 Bit Header CRC Algorithm for FlexRay Analysis Software
function CRC = Header_CRC(Message_Header)
%Initialise Variables
header = strcat(Message_Header(1,:),Message_Header(2,:)...
     ,Message_Header(3,:)); 
header = uint32(hex2dec(header)); 
header = bitshift(header,-1);
header = bitand(header,hex2dec('FFFFF'));
CrcInit = int32(hex2dec('1A'));
data_length = int32(20);
CrcNext = int32(0);
CrcPoly = uint64(hex2dec('385')); 
CrcReg_X = uint64(CrcInit);
header_temp = uint64(0);
reg_temp = uint64(0);
header = bitshift(header,11);
CrcReg_X = bitshift(CrcReg_X,21);
CrcPoly = bitshift(CrcPoly,21);
% CRC Algorithm
while(data_length)
    data_length = data_length -1;
    header = bitshift(header,1);
    header_temp = uint64(bitand(header,hex2dec('80000000')));
    reg_temp = bitand(CrcReg_X,hex2dec('80000000'));
    if (bitxor(header_temp,reg_temp))
        CrcNext = 1;
    else
        CrcNext = 0;
    end
    CrcReg_X = bitshift(CrcReg_X,1);
    if(CrcNext)
        CrcReg_X = bitxor(CrcReg_X,CrcPoly);
    end
end
% Format Output
CrcReg_X = bitshift(CrcReg_X,-21);
CrcReg_X = bitand(CrcReg_X,hex2dec('00000000000007FF'));
CRC = dec2hex(CrcReg_X);
end
